$LOAD_PATH.unshift File.dirname(__FILE__)

require 'json'
require 'rest-client'
require 'uri'
require 'logger'
require 'optparse'




module Dsc

  module Auto

    module HttpClient


      attr_accessor :host, :email, :password, :base_uri, :user_agent, :http, :content_type, :cookie, :token, :access_token, :data_files_path, :response, :parsed_response, :version, :log_level, :history, :auth_type

      def set_http_client_attributes(_args = {})
        @logger       = Logger.new(STDOUT)
        @log_level    = _args[:log_level] || "INFO"
        @logger.level = Logger.const_get(@log_level)

        @host     = _args[:host]
        @version  = _args[:version]
        @base_uri = _args[:base_uri] || "#{@host}/api/v#{@version}"

        @content_type = _args[:content_type] || :json

        @user_agent = _args[:user_agent] || "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) "\
                              "AppleWebKit/537.36 (KHTML, like Gecko) "\
                              "Chrome/48.0.2564.103 Safari/537.36"

        @token        = _args[:token]
        @cookie       = _args[:cookie]
        @access_token = _args[:access_token]

        @user
        @email    = _args[:email]
        @password = _args[:password]
        @auth_type = _args[:auth_type]
        @history  = []
      end
    end
  end
end


require_relative 'dsc_auto_http_client/http'
require_relative 'dsc_auto_http_client/parse_json'